/**
*
 
* Zilog Modbus TCP/IP Server
 
* Copyright (c), Andrzej Sokulski, 
 
* andrzej@modbus.pl - www.modbus.pl
 * All rights reserved.
 
* 
 
* 
 
*  This software is free you can redistribute it and/or
 
*  modify it under the terms of the GNU Lesser General Public
 
*  License as published by the Free Software Foundation; either
 
*  version 2.1 of the License, or (at your option) any later version.
 
*
 
*  This software is distributed in the hope that it will be useful,
 
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
 
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 
*  Lesser General Public License for more details. 
 
*  In no event shall the regents or contributors be liable for any direct,
 
*  indirect, incidential, special, exemplary, or consequential damages. 

 
*  Redistributions of source code should retain the above copyright notice,
 
*  If you want to remove the copyright notice, 
 
*  please donate me (www.modbus.pl/donate.html).
 
*
 
*/ 

#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <ztpconfig.h>
#include "ZSysgen.h"
#include "ZTypes.h"
#include "basetypes.h"
#include "ZThread.h"
#include "emulator.h"
#include "shell.h"
#include "Xc_lib.h"
#include "http.h"
#include "date.h"
#include "igmp.h"
#include "snmp.h"
#include "telnet_api.h"
#include "Telnet_Shell.h"
#include "FtpApi.h"
#include "FS_Shell.h"
#include "rtc.h"
#include "zfsapi.h"
#include "tcpstat.h"
#include "XtlTcp.h"
#include "modbus.h"
#include <ez80.h>

#define PRIORITY1		10		/** priority for thread #1 */
#define STACK_SIZE		2048	/** stack size for the thread */
#define RR_TICKS		1		/** round robin tick for the schedular */




extern void RZKFormatError(UINT num) ;
extern RZK_STATUS_t RZKGetErrorNum( ) ;
extern RZKStartup();
extern RZKEntry();
extern DID TCP;
//extern Webpage website[];

DID TCPSrvrDevID;
DID TCPConnDevID;

struct tcpstat TCPStat;   // defined in tcpstat.h file

INT16 addrlen = sizeof(struct sockaddr_in);

/*
* Request a TCP server device, set its listen depth
* to 2, and wait for a connection from a remote
* socket.
*/

SYSCALL main(void)
{

char address[25];
int state = 1;
int n_error;
int i;
int lport = 502;

/*******LED MATRIX*********************************************************/
/* Init the LED matrix                                                    */

CS2_LBR = 0x80;
CS2_UBR = 0xbf;
CS2_CTL = 0x28;
ZILOG_COILS[0] = 0;
ZILOG_COILS[1] = 0;
LEDMATRIX_ROW = ZILOG_COILS[0];
LEDMATRIX_COLUMN = ZILOG_COILS[1];

/***************************************************************************/

/*
* Request a TCP server device, set its listen depth
* to 2, and wait for a connection from a remote
* socket.
*/
//http_init(http_defmethods,httpdefheaders,website,80);

TCPSrvrDevID = open(TCP, ANYFPORT,(char*)lport);
if( TCPSrvrDevID != NULLPTR )
{
   control( TCPSrvrDevID, TCPC_LISTENQ, (char*)2,0);
   while (1){
             kprintf("\n Waiting for Modbus TCP connection. \n");
			 
             if (control(TCPSrvrDevID, TCPC_ACCEPT,(char*)&TCPConnDevID, NULLPTR)!=SYSERR)
			   {
                kprintf( "TCP connection device ID is %d\n",TCPConnDevID );
                RZKTCPEntry(TCPSrvrDevID,TCPConnDevID); // Create modbus tcp thread
			    } else{
	 		           kprintf("TCP accept error");
				       return 0;
				       }
           }
  }else
       kprintf("Can't open TCP Error nr %d\n",TCPSrvrDevID);


	return(OK);
}
