#ifndef MODBUS_H
#define MODBUS_H

#define MAX_ZILOG_REG 256   
#define MAX_ZILOG_COIL 32   
#define MAX_ZILOG_IREG 16 
#define MAX_ZILOG_INPUT 32 

#define LEDMATRIX_ROW      (*(unsigned char*)0x800000)  //Anode
#define LEDMATRIX_COLUMN   (*(unsigned char*)0x800001)  //Cathode

unsigned char ZILOG_COILS[MAX_ZILOG_COIL/8];
unsigned char ZILOG_REG[MAX_ZILOG_REG*2];   
unsigned char ZILOG_IREG[MAX_ZILOG_IREG*2]; 
unsigned char ZILOG_INPUTS[MAX_ZILOG_INPUT/32];
unsigned char SlaveAddress = 1;

void checkModbusFrame(unsigned char *ptrFrame, unsigned int size);
void setBits(unsigned char* srcTable, unsigned char* destTable, unsigned int destStartBit, unsigned int nrOfBits);
void getBits(unsigned char* srcTable, unsigned char* destTable, unsigned int srcStartBit, unsigned int nrOfBits);
void wrongModbusFrame(unsigned char* ptrFrame);
void voidpresetCoilModbusFrame(unsigned char* ptrFrame,unsigned int size);
void writeCoilModbusFrame(unsigned char* ptrFrame,unsigned int size);
void readCoilModbusFrame(unsigned char* ptrFrame, unsigned int size);
void readInputModbusFrame(unsigned char* ptrFrame, unsigned int size);
void presetRegModbusFrame(unsigned char* ptrFrame,unsigned int size);
void writeRegModbusFrame(unsigned char* ptrFrame,unsigned int size);
void readRegModbusFrame(unsigned char* ptrFrame,unsigned int size);
void readIRegModbusFrame(unsigned char* ptrFrame,unsigned int size);
void presetCoilModbusFrame(unsigned char* ptrFrame,unsigned int size);

#endif /* MODBUS_H */
