/*
 * Copyright 2003, ZiLOG Inc.
 * All Rights Reserved
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of ZiLOG Inc., and might
 * contain proprietary, confidential and trade secret information of
 * ZiLOG, our partners and parties from which this code has been licensed.
 * 
 * The contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of ZiLOG Inc.
 */
 /*
 * Copyright 2001, Metro Link, Inc.
 * All Rights Reserved
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Metro Link, Inc. and may
 * contain proprietary, confidential and trade secret information of
 * Metro Link, Inc. and/or its partners.
 *  
 * The contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Metro Link, Inc.
 *
 */

#ifndef TCPSTAT_H
#define TCPSTAT_H
/* tcpstat.h */

/*	The union returned by the TCP STATUS control call		*/
struct tcpstat {
	BYTE	ts_type;	/* which kind of TCP status?		*/
	union {
		struct {
			DWORD		tsu_connects;	/* # connections	*/
			DWORD		tsu_aborts;	/* # aborts		*/
			DWORD		tsu_retrans;	/* # retransmissions	*/
		} T_unt;
		struct {
			IPaddr	tsu_laddr;	/* local IP		*/
			WORD		tsu_lport;	/* local TCP port	*/
			IPaddr	tsu_faddr;	/* foreign IP		*/
			WORD		tsu_fport;	/* foreign TCP port	*/
			WORD		tsu_rwin;	/* receive window	*/
			WORD		tsu_swin;	/* peer's window	*/
			BYTE		tsu_state;	/* TCP state		*/
			WORD		tsu_unacked;	/* bytes unacked	*/
			BYTE		tsu_prec;	/* IP precedence	*/
		} T_unc;
		struct {
			DWORD		tsu_requests;	/* # connect requests	*/
			DWORD		tsu_qmax;	/* max queue length	*/
		} T_uns;
	} T_un;
};

#define	ts_connects	T_un.T_unt.tsu_connects
#define	ts_aborts	T_un.T_unt.tsu_aborts
#define	ts_retrans	T_un.T_unt.tsu_retrans

#define	ts_laddr		T_un.T_unc.tsu_laddr
#define	ts_lport		T_un.T_unc.tsu_lport
#define	ts_faddr		T_un.T_unc.tsu_faddr
#define	ts_fport		T_un.T_unc.tsu_fport
#define	ts_rwin		T_un.T_unc.tsu_rwin
#define	ts_swin		T_un.T_unc.tsu_swin
#define	ts_state		T_un.T_unc.tsu_state
#define	ts_unacked	T_un.T_unc.tsu_unacked
#define	ts_prec		T_un.T_unc.tsu_prec

#define	ts_requests	T_un.T_uns.tsu_requests
#define	ts_qmax		T_un.T_uns.tsu_qmax

#endif /* TCPSTAT_H */
